//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
 /******************************************************************
*
*
*                      SET CARACTERE
*
*
*******************************************************************/

const char character[] = {16,6,9,8,8,9,6,0};


void CustomChar(char pos_row, char pos_char) {
  char i;
    Lcd_Cmd(64);
    for (i = 0; i<=7; i++) Lcd_Chr_CP(character[i]);
    Lcd_Cmd(_LCD_RETURN_HOME);
    Lcd_Chr(pos_row, pos_char, 0);
}



const unsigned short TEMP_RESOLUTION = 9;

char *text = " 00.00";
unsigned temp;

void Display_Temperature(char linia,char coloana,unsigned int temp2write) {
  const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
  char temp_whole;
  unsigned int temp_fraction;

  // Check if temperature is negative
  if (temp2write & 0x8000) {
     text[0] = '-';
     temp2write = ~temp2write + 1;
     }

  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;

  // Convert temp_whole to characters
  if (temp_whole/100)
     text[0] = temp_whole/100  + 48;
   if(!(temp_whole/100))
     text[0] = ' ';

  text[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
  text[2] =  temp_whole%10     + 48;             // Extract ones digit

  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;

  // Convert temp_fraction to characters
  text[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
  text[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
 // text[6] = (temp_fraction/10)%10  + 48;         // Extract tens digit
 // text[7] =  temp_fraction%10      + 48;         // Extract ones digit
  //text[6] = 'C';
  // Print temperature on LCD
  Lcd_Out(linia, coloana, text); CustomChar(linia,coloana+6) ;
   if(((temp_whole/10)%10) >= 5) PORTD.F1=1;       // Aici setez temp de pornire cooler [5=50 grade]
   else PORTD.F1=0;
}

void afisare_temperatura(char linia,char coloana)
 {
    //--- Perform temperature reading
    Ow_Reset(&PORTD, 0);                         // Onewire reset signal
    Ow_Write(&PORTD, 0, 0xCC);                   // Issue command SKIP_ROM
    Ow_Write(&PORTD, 0, 0x44);                   // Issue command CONVERT_T
    Delay_us(120);

    Ow_Reset(&PORTD, 0);
    Ow_Write(&PORTD, 0, 0xCC);                   // Issue command SKIP_ROM
    Ow_Write(&PORTD, 0, 0xBE);                   // Issue command READ_SCRATCHPAD

    temp =  Ow_Read(&PORTD, 0);
    temp = (Ow_Read(&PORTD, 0) << 8) + temp;

    //--- Format and display result on Lcd
    Display_Temperature(linia,coloana,temp);

    Delay_ms(900);

}